clang 8.0.0

Public Types | Static Public Member Functions | List of all members
clang::CodeGen::DominatingLLVMValue Struct Reference

Helper class with most of the code for saving a value for a conditional expression cleanup. More...

`#include "/work/www-prereleases/8.0.0/rc2/builddocs/llvm.src/tools/clang/lib/CodeGen/CodeGenFunction.h"`

Inheritance diagram for clang::CodeGen::DominatingLLVMValue:
[legend]

## Public Types
typedef llvm::PointerIntPair< llvm::Value *, 1, bool > | saved_type

## Static Public Member Functions
static bool | needsSaving (llvm::Value *value)
| Answer whether the given value needs extra work to be saved. More...
static saved_type | save (CodeGenFunction &CGF, llvm::Value *value)
static llvm::Value * | restore (CodeGenFunction &CGF, saved_type value)

## Detailed Description

Helper class with most of the code for saving a value for a conditional expression cleanup.

Definition at line 145 of file CodeGenFunction.h.

## Member Typedef Documentation

## ◆ saved_type

typedef llvm::PointerIntPair<llvm::Value*, 1, bool> clang::CodeGen::DominatingLLVMValue::saved_type

Definition at line 146 of file CodeGenFunction.h.

## Member Function Documentation

## ◆ needsSaving()

static bool clang::CodeGen::DominatingLLVMValue::needsSaving | ( | llvm::Value * | value | ) |
| inline static

Answer whether the given value needs extra work to be saved.

Definition at line 149 of file CodeGenFunction.h.

## ◆ restore()

llvm::Value * clang::CodeGen::DominatingLLVMValue::restore | ( | CodeGenFunction & | CGF,
|  | saved_type | value
| ) |  |
| inline static

Definition at line 4360 of file CodeGenFunction.h.

References clang::CodeGen::CodeGenFunction::Builder, and clang::CodeGen::CGBuilderTy::CreateAlignedLoad().

## ◆ save()

DominatingLLVMValue::saved_type clang::CodeGen::DominatingLLVMValue::save | ( | CodeGenFunction & | CGF,
|  | llvm::Value * | value
| ) |  |
| inline static

Definition at line 4347 of file CodeGenFunction.h.

References clang::CodeGen::CodeGenFunction::Builder, clang::CodeGen::CodeGenFunction::CGM, clang::CodeGen::CGBuilderTy::CreateStore(), clang::CodeGen::CodeGenFunction::CreateTempAlloca(), clang::CodeGen::CodeGenModule::getDataLayout(), and clang::CodeGen::Address::getPointer().

The documentation for this struct was generated from the following file:

- lib/CodeGen/CodeGenFunction.h